/* programador de 8255 en puerto paralelo */
/* realizado en TC ++ 3.0 */

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <bios.h>
#include <ctype.h>
#include <io.h>
#include <dos.h>
#include <alloc.h>

#include "setawin.h"
#include "w8255.h"

char VNombre[]="W8255";

int      PASCAL        WinMain(HANDLE hinstancia, HANDLE hPrevInstance,LPSTR lpszCmdLine, int cmdShow);
BOOL FAR PASCAL        acerca(HWND hDlg, WORD message, WORD wParam, LONG lParam);
long FAR PASCAL        w8255WndProc(HWND hWnd, WORD message,WORD wParam, LONG lParam);
void                   w8255Paint(void);

HBITMAP	  hBitmapM,hBit1,hBit2,hBit3;
HDC          hdcM;
HDC          hdcMemM;

void panta(void);
void printc8x16(int x,int y,unsigned char nombre[80]);
void refresco(void);

void c_control(char a,char b,char c1,char c2);
unsigned char c_in(unsigned char p);
void c_out(unsigned char p, unsigned char d);


unsigned char modoin=0;
unsigned char xa=1,xb=1,xc1=1,xc2=1,da,db,dc;
char *led="**";
char te;
unsigned char zc;
int z,zona,tiempo,parada;


#pragma argsused
int PASCAL WinMain(HANDLE hinstancia, HANDLE hPrevInstance,LPSTR lpszCmdLine, int cmdShow)
{
    MSG   msg;
    WNDCLASS wcw8255;

    wcw8255.lpszClassName = VNombre;
    wcw8255.hInstance     = hinstancia;
    wcw8255.lpfnWndProc   = w8255WndProc;
    wcw8255.hCursor       = LoadCursor(NULL,IDC_ARROW);
    wcw8255.hIcon         = LoadIcon(hinstancia,"ICON_1");
    wcw8255.lpszMenuName  = "MENU1";
    wcw8255.hbrBackground = GetStockObject(WHITE_BRUSH);
    wcw8255.style         = CS_HREDRAW | CS_VREDRAW;
    wcw8255.cbClsExtra    = 0;
    wcw8255.cbWndExtra    = 0;

    if(!RegisterClass(&wcw8255)){printf("error al registrar clase"); return 0;}

    hInst = hinstancia;
    hprincipal = CreateWindow(
		  VNombre,     // window class name
		  VNombre,     // window title
		  WS_OVERLAPPEDWINDOW,    // type of window
		  0,           // x  window location
		  0,                       // y
		  640,           // cx and size
		  450,                       // cy
		  NULL,                    // no parent for this window
		  NULL,                    // use the class menu
		  hinstancia,               // who created this window
		  NULL                     // no parms to pass on
		  );
    font=CreateFont(16,8,0,0,500,
				0,0,0,ANSI_CHARSET,
				OUT_DEFAULT_PRECIS,
				CLIP_DEFAULT_PRECIS,
				DEFAULT_QUALITY,
				DEFAULT_PITCH | FF_DONTCARE,
				"Courier New");

    hdcM     = GetDC(hprincipal);
    hdcMemM  = CreateCompatibleDC (hdcM) ;
    hBitmapM = CreateCompatibleBitmap (hdcM,60,100) ;

    hBit1=LoadBitmap(hInst,"BANDERA");
    hBit2=LoadBitmap(hInst,"ROJO");
    hBit3=LoadBitmap(hInst,"VERDE");

    ShowWindow(hprincipal, SW_SHOW);
    UpdateWindow(hprincipal);
    SetTimer(hprincipal,1,200,NULL);
    c_control(xa,xb,xc1,xc2);
    while (GetMessage(&msg, NULL, 0, 0))
	  {
	   TranslateMessage(&msg);
	   DispatchMessage(&msg);
	  }

    DeleteObject(hBit1);
    DeleteObject(hBit2);
    DeleteObject(hBit3);
    DeleteObject (hBitmapM) ;
    DeleteObject(font);
    DeleteDC (hdcMemM);
    ReleaseDC(hprincipal,hdcM);

    KillTimer(hprincipal,1);
    return(msg.wParam);
}

#pragma argsused
BOOL FAR PASCAL acerca(HWND hDlg, WORD message, WORD wParam, LONG lParam)
{
	switch(message)
		{
		 case WM_COMMAND:
			switch(LOWORD(wParam))
			 {
			  case ID_OK:
				EndDialog(hDlg,0);
				return 1;
			 }
		}
 return 0;
}

#pragma argsused
BOOL FAR PASCAL fcontrol(HWND hDlg, WORD message, WORD wParam, LONG lParam)
{
	switch(message)
		{
		 case WM_INITDIALOG:
			if(xa==0)
				SendDlgItemMessage(hDlg,ID_PORTAOUT,BM_SETCHECK,1,0);
			      else
				SendDlgItemMessage(hDlg,ID_PORTAIN,BM_SETCHECK,1,0);
			if(xb==0)
				SendDlgItemMessage(hDlg,ID_PORTBOUT,BM_SETCHECK,1,0);
			      else
				SendDlgItemMessage(hDlg,ID_PORTBIN,BM_SETCHECK,1,0);
			if(xc1==0)
				SendDlgItemMessage(hDlg,ID_PORTC1OUT,BM_SETCHECK,1,0);
			      else
				SendDlgItemMessage(hDlg,ID_PORTC1IN,BM_SETCHECK,1,0);
			if(xc2==0)
				SendDlgItemMessage(hDlg,ID_PORTC2OUT,BM_SETCHECK,1,0);
			      else
				SendDlgItemMessage(hDlg,ID_PORTC2IN,BM_SETCHECK,1,0);
			break;
		 case WM_COMMAND:

			switch(LOWORD(wParam))
			 {
			  case ID_PORTAOUT:
				SendDlgItemMessage(hDlg,ID_PORTAIN,BM_SETCHECK,0,0);
				SendDlgItemMessage(hDlg,ID_PORTAOUT,BM_SETCHECK,1,0);
				break;
			  case ID_PORTBOUT:
				SendDlgItemMessage(hDlg,ID_PORTBIN,BM_SETCHECK,0,0);
				SendDlgItemMessage(hDlg,ID_PORTBOUT,BM_SETCHECK,1,0);
				break;
			  case ID_PORTC1OUT:
				SendDlgItemMessage(hDlg,ID_PORTC1IN,BM_SETCHECK,0,0);
				SendDlgItemMessage(hDlg,ID_PORTC1OUT,BM_SETCHECK,1,0);
				break;
			  case ID_PORTC2OUT:
				SendDlgItemMessage(hDlg,ID_PORTC2IN,BM_SETCHECK,0,0);
				SendDlgItemMessage(hDlg,ID_PORTC2OUT,BM_SETCHECK,1,0);
				break;
			  case ID_PORTAIN:
				SendDlgItemMessage(hDlg,ID_PORTAIN,BM_SETCHECK,1,0);
				SendDlgItemMessage(hDlg,ID_PORTAOUT,BM_SETCHECK,0,0);
				break;
			  case ID_PORTBIN:
				SendDlgItemMessage(hDlg,ID_PORTBIN,BM_SETCHECK,1,0);
				SendDlgItemMessage(hDlg,ID_PORTBOUT,BM_SETCHECK,0,0);
				break;
			  case ID_PORTC1IN:
				SendDlgItemMessage(hDlg,ID_PORTC1IN,BM_SETCHECK,1,0);
				SendDlgItemMessage(hDlg,ID_PORTC1OUT,BM_SETCHECK,0,0);
				break;
			  case ID_PORTC2IN:
				SendDlgItemMessage(hDlg,ID_PORTC2IN,BM_SETCHECK,1,0);
				SendDlgItemMessage(hDlg,ID_PORTC2OUT,BM_SETCHECK,0,0);
				break;
			  case ID_OKC:
				if(SendDlgItemMessage(hDlg,ID_PORTAOUT,BM_GETCHECK,0,0)) xa=0; else xa=1;
				if(SendDlgItemMessage(hDlg,ID_PORTBOUT,BM_GETCHECK,0,0)) xb=0; else xb=1;
				if(SendDlgItemMessage(hDlg,ID_PORTC1OUT,BM_GETCHECK,0,0)) xc1=0; else xc1=1;
				if(SendDlgItemMessage(hDlg,ID_PORTC2OUT,BM_GETCHECK,0,0)) xc2=0; else xc2=2;
				c_control(xa,xb,xc1,xc2);
				EndDialog(hDlg,0);
				return 1;
			  case ID_CANCELC:
				EndDialog(hDlg,0);
				return 1;
			 }
		}
 return 0;
}


long FAR PASCAL w8255WndProc(HWND hWnd, WORD message, WORD wParam, LONG lParam)
{
    switch (message)
    {
	case WM_CHAR:
	     te=wParam;
	     switch(te)
			{
			 case '1':
				if(da&1) da-=1; else da+=1;
			 break;
			 case '2':
				if(da&2) da-=2; else da+=2;
			 break;
			 case '3':
				if(da&4) da-=4; else da+=4;
			 break;
			 case '4':
				if(da&8) da-=8; else da+=8;
			 break;
			 case '5':
				if(da&16) da-=16; else da+=16;
			 break;
			 case '6':
				if(da&32) da-=32; else da+=32;
			 break;
			 case '7':
				if(da&64) da-=64; else da+=64;
			 break;
			 case '8':
				if(da&128) da-=128; else da+=128;
			 break;

			 case 'q':
				if(db&1) db-=1; else db+=1;
			 break;
			 case 'w':
				if(db&2) db-=2; else db+=2;
			 break;
			 case 'e':
				if(db&4) db-=4; else db+=4;
			 break;
			 case 'r':
				if(db&8) db-=8; else db+=8;
			 break;
			 case 't':
				if(db&16) db-=16; else db+=16;
			 break;
			 case 'y':
				if(db&32) db-=32; else db+=32;
			 break;
			 case 'u':
				if(db&64) db-=64; else db+=64;
			 break;
			 case 'i':
				if(db&128) db-=128; else db+=128;
			 break;


			 case 'a':
				if(dc&1) dc-=1; else dc+=1;
			 break;
			 case 's':
				if(dc&2) dc-=2; else dc+=2;
			 break;
			 case 'd':
				if(dc&4) dc-=4; else dc+=4;
			 break;
			 case 'f':
				if(dc&8) dc-=8; else dc+=8;
			 break;
			 case 'g':
				if(dc&16) dc-=16; else dc+=16;
			 break;
			 case 'h':
				if(dc&32) dc-=32; else dc+=32;
			 break;
			 case 'j':
				if(dc&64) dc-=64; else dc+=64;
			 break;
			 case 'k':
				if(dc&128) dc-=128; else dc+=128;
			 break;
			 case 'x':
				if(modoin==0)modoin=1; else modoin=0;
				panta();
			 break;
			}
	     refresco();
	     break;
	case WM_CREATE:
	     panta();
	     break;
	case WM_LBUTTONUP:
	     zona=gzona(LOWORD(lParam),HIWORD(lParam));
	     break;
	case WM_LBUTTONDOWN:
	     zona=gzona(LOWORD(lParam),HIWORD(lParam));

	     break;
	case WM_MOUSEMOVE:
	     zona=gzona(LOWORD(lParam),HIWORD(lParam));
	     break;
	case WM_COMMAND:
	    switch (wParam)
	    {
		case IDM_QUIT:
		    PostMessage(hWnd, WM_CLOSE, 0, 0L);
		    break;
		case IDM_ACERCA:
		    DialogBox(hInst,"ACERCA",hWnd,acerca);
		    break;
		case IDM_CONTROL:
		    DialogBox(hInst,"CONTROL",hWnd,fcontrol);
		    te=255;
		    break;
		default:
		    break;
	    }
	    break;
	case WM_PAINT:
	    w8255Paint();
	    break;
	case WM_TIMER:
	    refresco();
	    break;
	case WM_CLOSE:
	    DestroyWindow(hprincipal);
	    break;
	case WM_DESTROY:
	     PostQuitMessage(0);
	     break;
	default:
	    return(DefWindowProc(hWnd, message, wParam, lParam));
    }
    return(0L);
}

void panta(void)
{
       ink(0,128,128);
       bar(0,0,640,450);
       ink(0,0,255);
/*       line(40,120,440,120); line(440,0,440,450);line(40,0,40,450);
       ink(0,0,0);
       ink(0,128,128); printc(450,1,"TIEMPO");
*/
	printc8x16(25,0,"Programador del 8255");
	printc8x16(24,21,"   (c) SETA 2001    ");
	INK=15;
	printc8x16(2,23,"Tecla x, cambio de modo");
	if(modoin==0) printc8x16(50,23,"Modo standard           "); else 	 printc8x16(50,23,"Modo Bidireccional");
	INK=14;
	printc8x16(2,5,"PUERTO A");
	printc8x16(2,10,"PUERTO B");
	printc8x16(2,15,"PUERTO C");
	INK=9;
	printc8x16(25,3,"D0 D1 D2 D3 D4 D5 D6 D7 ");
	printc8x16(18,6,"Teclas  1  2  3  4  5  6  7  8");
	printc8x16(18,11,"Teclas  q  w  e  r  t  y  u  i");
	printc8x16(18,17,"Teclas  a  s  d  f  g  h  j  k");
	te=255; refresco();
}

int gzona( int x,int y)
{
int z;
	     z=0;
	     if(x>460 && x<560 && y<200){z=9; goto fin;}
	     if(x>560 && y<200){z=10; goto fin;}
	     if(x>60 && x<160){z=1; goto salto;}
	     if(x>160 && x<260){z=2; goto salto;}
	     if(x>260 && x<360){z=3; goto salto;}
	     if(x>360 && x<460) z=4;
 salto:
	     if(y>120 && z!=0) z+=4;
 fin:
 return(z);
}


void w8255Paint(void)
{

 PAINTSTRUCT  ps;
 HDC          hDC;

       hDC=BeginPaint(hprincipal, (LPPAINTSTRUCT) &ps);
       TextOut(hDC,0,0," ",1);
       EndPaint(hprincipal, (LPPAINTSTRUCT) &ps);
       panta();
}

void printc8x16(int x,int y,unsigned char nombre[80])
{
	printc(x<<3,y<<4,nombre);
}

void refresco(void)
{
 HDC    DC,memDC;

	DC=GetDC(hprincipal);
	memDC=CreateCompatibleDC(DC);
	if(te!=0)
	    {
		 te=0;
		 if(xa>0) {ink(0,255,0); printc8x16(5,6,"ENTRADAS ");} else {ink(255,0,0);printc8x16(5,6,"SALIDAS  ");}
		 if(xb>0) {ink(0,255,0);printc8x16(5,11,"ENTRADAS ");} else {ink(255,0,0);printc8x16(5,11,"SALIDAS  ");}
		 if(xc1|=0){ink(0,255,0); printc8x16(25,16,"C1-ENTRADAS ");} else {ink(255,0,0);printc8x16(25,16,"C1-SALIDAS  ");}
		 if(xc2|=0){ink(0,255,0); printc8x16(37,16,"C2-ENTRADAS ");} else {ink(255,0,0);printc8x16(37,16,"C2-SALIDAS  ");}
			 zc=da;
			 for(z=25;z<49;z+=3)
				{
				 if(zc&1) SelectObject(memDC,hBit2); else SelectObject(memDC,hBit1);
				 BitBlt(DC,z*8,7*16,16,16,memDC,0,0,SRCCOPY);
				 zc=zc>>1;
				}
			 zc=db;
			 for(z=25;z<49;z+=3)
				{
				 if(zc&1) SelectObject(memDC,hBit2); else SelectObject(memDC,hBit1);
				 BitBlt(DC,z*8,12*16,16,16,memDC,0,0,SRCCOPY);
				 zc=zc>>1;
				}
			 zc=dc;
			 for(z=25;z<49;z+=3)
				{
				 if(zc&1) SelectObject(memDC,hBit2); else SelectObject(memDC,hBit1);
				 BitBlt(DC,z*8,18*16,16,16,memDC,0,0,SRCCOPY);
				 zc=zc>>1;
				}
			c_out('a',da);
			c_out('b',db);
			c_out('c',dc);
	    }
		 if(xa>0)
			{
			 zc=c_in('a');
			 for(z=25;z<49;z+=3)
				{
				 if(zc&1) SelectObject(memDC,hBit3); else SelectObject(memDC,hBit1);
				 BitBlt(DC,z*8,8*16,16,16,memDC,0,0,SRCCOPY);
				 zc=zc>>1;
				}
			}

		 if(xb>0)
			{
			 zc=c_in('b');
			 for(z=25;z<49;z+=3)
				{
				 if(zc&1) SelectObject(memDC,hBit3); else SelectObject(memDC,hBit1);
				 BitBlt(DC,z*8,13*16,16,16,memDC,0,0,SRCCOPY);
				 zc=zc>>1;
				}
			}
		 if(xc2>0 || xc1>0)
			{
			 zc=c_in('c');
			 for(z=25;z<49;z+=3)
				{
				 if(zc&1) SelectObject(memDC,hBit3); else SelectObject(memDC,hBit1);
				 BitBlt(DC,z*8,19*16,16,16,memDC,0,0,SRCCOPY);
				 zc=zc>>1;
				}
			}
	ReleaseDC(hprincipal,DC);
	DeleteDC(memDC);
}



/* solo modo 0 de 8255 */
/* 0=salida  1=entrada */
void c_control(char a,char b,char c1,char c2)
{
unsigned char z;
	xa=xb=xc1=xc2=0;
	z=0;
	if(c2>0) {z=8; xc2=1;}
	if(b>0) {z+=2; xb=1;}
	if(c1>0) {z+=1; xc1=1;}
	if(a>0) {z+=16; xa=1;}
	z+=128;
	c_out('x',z);
}

unsigned char c_in(unsigned char p)
{
unsigned char c,c1,byte;
int z;
	byte=0;
	switch(p)
			{
			case 'a':
				 if(modoin==0)
				{
				 outportb(890,14);
				 outportb(890,15);
				 for(c1=0;c1<8;c1++)
					{
					 byte=byte>>1;
					 outportb(888,c1); outportb(888,c1);
					 c=inportb(889)&32; c=inportb(889)&32;
					 if(32==c) byte=byte|128;
					}
				 outportb(890,14);
		}
				 else
				 {
				  outportb(890,14);
				  outportb(890,15);
				   outportb(890,15+32);
				   byte=inportb(888);
				  outportb(890,14);
				 }
			 break;
			 case 'b':
				if(modoin==0)
				{
				 outportb(890,6);
				 outportb(890,7);
				 for(c1=0;c1<8;c1++)
					{
					 byte=byte>>1;
					 outportb(888,c1); outportb(888,c1);
					 c=inportb(889)&32; c=inportb(889)&32;
					 if(32==c) byte=byte|128;
					}
				  outportb(890,6);
				 }
				 else
				 {
				  outportb(890,6);
				 outportb(890,7);
				   outportb(890,7+32);
				   byte=inportb(888);
				 outportb(890,6);
				 }
			 break;
			 case 'c':
				if(modoin==0)
				{
				 outportb(890,12);
				 outportb(890,13);
				 for(c1=0;c1<8;c1++)
					{
					 byte=byte>>1;
					 outportb(888,c1); outportb(888,c1);
					 c=inportb(889)&32; c=inportb(889)&32;
					 if(32==c) byte=byte|128;
					}
				 outportb(890,12);
				}
				else
				{
				 outportb(890,12);
				 outportb(890,13);
				   outportb(890,13+32);
				   byte=inportb(888);
				 outportb(890,12);
				}
			 break;
			}
	return(byte);
}

/* p= a,b,c,x siendo x de control */
void c_out(unsigned char p, unsigned char d)
{
	switch(p)
			{
			 case 'a':
				da=d;
/*				printf("c_out A= %d\n",d); */
				outportb(890,14);
				outportb(888,d);
				outportb(890,10);
				outportb(890,14);
			 break;
			 case 'b':
				db=d;
/*				printf("c_out B= %d\n",d); */
				outportb(890,6);
				outportb(888,d);
				outportb(890,2);
				outportb(890,6);
			 break;
			 case 'c':
				dc=d;
/*				printf("c_out C= %d\n",d); */
				outportb(890,12);
				outportb(888,d);
				outportb(890,8);
				outportb(890,12);
			 break;
			 case 'x':
				printf("Control c_out %d\n",d);
				outportb(890,4);
				outportb(888,d);
				outportb(890,0);
				outportb(890,4);
			 break;
			}
}