/* -----------setawin.c --------------*/
/* -----------17-octubre -2001 -----*/
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

void printc(int x,int y,unsigned char nombre[80]);
void mks(long num);
void printn(int x,int y,long num);
void plot(int x,int y,DWORD c);
int point(int x,int y);
void line(int x,int y,int xx,int yy);
void box(int x,int y,int xx,int yy);
void bar(int x,int y,int xx,int yy);
void paper(BYTE r,BYTE g,BYTE b);
void ink(BYTE r,BYTE g,BYTE b);
void clear(unsigned char c);
void velocidad(void);
void impri(int x,int y,unsigned char ca);
void waits(unsigned int x);


int INK,PAPER,SPEED,XMOUSE,YMOUSE,KMOUSE,CMOUSE,MX,MY,MK,SETIM,Tecla;
unsigned char Rink=0,Gink=0,Bink=0;
unsigned char Rpaper=255,Gpaper=255,Bpaper=255;
unsigned char VARI[80];

FILE *pf;
/* variables windows */

HANDLE    hInst;
HWND      hprincipal;
HFONT     font;


/*-----------------------------------------------------------------*/

/* ------espera x segundos-------*/
void waits(unsigned int x)
{
 unsigned int ti,z;

 ti=time(NULL) ; z=ti; ti+=x ; while(ti-z>1) z=time(NULL);
}


/* ---- IMPRIME CARACTER  ---- */
void impri(int x,int y,unsigned char ca)
{
HDC       hDC;
    VARI[0]=ca;
    hDC=GetDC(hprincipal);
    SetBkColor(hDC,RGB(Rpaper,Gpaper,Bpaper));
    SetTextColor(hDC,RGB(Rink,Gink,Bink));
    TextOut(hDC,x,y,VARI,1);
    ReleaseDC(hprincipal,hDC);
}
/* ---- TRANSFORMA NUMERO A CADENA ----*/
void mks(long num)
{
 int z;
 for(z=0;z<40;z++)VARI[z]=0;
 sprintf(VARI,"%d",num);
}

/* ---- IMPRIME NUMERO ----*/
void printn(int x,int y,long num)
{
 mks(num);
 printc(x,y,VARI);
}
/*----- IMPRIME CADENA ------*/
void printc(int x,int y,unsigned char nombre[80])
{
HDC       hDC;
    hDC=GetDC(hprincipal);
    SetBkColor(hDC,RGB(Rpaper,Gpaper,Bpaper));
    SetTextColor(hDC,RGB(Rink,Gink,Bink));
    SelectObject(hDC,font);
    TextOut(hDC,x,y,nombre,lstrlen(nombre));
    ReleaseDC(hprincipal,hDC);
}

/*---- IMPRIME PUNTO ---- */
void plot(int x,int y,DWORD c)
{
HDC       hDC;
    hDC=GetDC(hprincipal);
    SetPixel(hDC,x,y,c);
    ReleaseDC(hprincipal,hDC);
}

/* ----- IMPRIME LINEA ---- */
void line(int x,int y,int xx,int yy)
{
HDC       hDC;
   hDC=GetDC(hprincipal);
   MoveTo(hDC,x,y);
   LineTo(hDC,xx,yy);
   ReleaseDC(hprincipal,hDC);
}

void box(int x,int y,int xx,int yy)
{
 HPEN hp,hpv;
 HDC       hDC;
        hDC=GetDC(hprincipal);
        hp=CreatePen(PS_SOLID,1,RGB(Rink,Gink,Bink));
        hpv=SelectObject(hDC,hp);
        SelectObject(hDC,GetStockObject(HOLLOW_BRUSH));
        Rectangle(hDC,x,y,xx,yy);
        SelectObject(hDC,hpv);
        DeleteObject(hp);
        ReleaseDC(hprincipal,hDC);
}

void bar(int x,int y,int xx,int yy)
{
 HBRUSH hb,hbv;
 HDC       hDC;
        hDC=GetDC(hprincipal);
        hb=CreateSolidBrush(RGB(Rink,Gink,Bink));
        hbv=SelectObject(hDC,hb);
        SelectObject(hDC,GetStockObject(NULL_PEN));
        Rectangle(hDC,x,y,xx,yy);
        SelectObject(hDC,hbv);
        DeleteObject(hb);
        ReleaseDC(hprincipal,hDC);
}

void paper(BYTE r,BYTE g,BYTE b)
{
        Rpaper=r;
        Gpaper=g;
        Bpaper=b;
}

void ink(BYTE r,BYTE g,BYTE b)
{
        Rink=r;
        Gink=g;
	Bink=b;
}

void clear(unsigned char c)
{
HDC       hDC;
        c++;
	hDC=GetDC(hprincipal);
        Rectangle(hDC,0,0,1000,1000);
        ReleaseDC(hprincipal,hDC);
}

void velocidad(void)
{
 int z,zz;

 z=(0x00000fff & time(NULL));
 zz=0;
 while(z==(0x00000fff & time(NULL)));
 z=(0x00000fff & time(NULL));
 while(z==(0x00000fff & time(NULL))){ zz++; printc(0,0,"");}
 SPEED=zz;
}

